



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>图像处理------基于Otsu阈值二值化</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">图像处理------基于Otsu阈值二值化</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-02 05:43:26 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一：基本原理</strong></p>
<p>该方法是图像二值化处理常见方法之一，在Matlab与OpenCV中均有实现。</p>
<p>Otsu Threshing方法是一种基于寻找合适阈值实现二值化的方法，其最重</p>
<p>要的部分是寻找图像二值化阈值，然后根据阈值将图像分为前景（白色）</p>
<p>或者背景（黑色）。假设有6x6的灰度图像，其像素数据及其对应的直方</p>
<p>图如下图：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150223122638812"></p>
<p>阈值寻找方法首先假设是为T=3，则背景像素的比重、均值、方差的计算</p>
<p>结果如下：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150223122945854"></p>
<p>根据前景像素直方图，计算比重、均值、方差的过程如下：</p>
<p>,&nbsp;0,&nbsp;width,&nbsp;height,&nbsp;inPixels&nbsp;);</li>
<li>int&nbsp;index&nbsp;=&nbsp;0;</li>
<li>for(int&nbsp;row=0;&nbsp;row&lt;height;&nbsp;row++)&nbsp;{</li>
<li>int&nbsp;ta&nbsp;=&nbsp;0,&nbsp;tr&nbsp;=&nbsp;0,&nbsp;tg&nbsp;=&nbsp;0,&nbsp;tb&nbsp;=&nbsp;0;</li>
<li>for(int&nbsp;col=0;&nbsp;col&lt;width;&nbsp;col++)&nbsp;{</li>
<li>index&nbsp;=&nbsp;row&nbsp;*&nbsp;width&nbsp;+&nbsp;col;</li>
<li>ta&nbsp;=&nbsp;(inPixels[index]&nbsp;&gt;&gt;&nbsp;24)&nbsp;&amp;&nbsp;0xff;</li>
<li>tr&nbsp;=&nbsp;(inPixels[index]&nbsp;&gt;&gt;&nbsp;16)&nbsp;&amp;&nbsp;0xff;</li>
<li>tg&nbsp;=&nbsp;(inPixels[index]&nbsp;&gt;&gt;&nbsp;8)&nbsp;&amp;&nbsp;0xff;</li>
<li>tb&nbsp;=&nbsp;inPixels[index]&nbsp;&amp;&nbsp;0xff;</li>
<li>int&nbsp;gray=&nbsp;(int)(0.299&nbsp;*tr&nbsp;+&nbsp;0.587*tg&nbsp;+&nbsp;0.114*tb);</li>
<li>inPixels[index]&nbsp;&nbsp;=&nbsp;(ta&nbsp;&lt;&lt;&nbsp;24)&nbsp;|&nbsp;(gray&nbsp;&lt;&lt;&nbsp;16)&nbsp;|&nbsp;(gray&nbsp;&lt;&lt;&nbsp;8)&nbsp;|&nbsp;gray;</li>
<li>}</li>
<li>}</li>
<li>//&nbsp;获取直方图</li>
<li>int[]&nbsp;histogram&nbsp;=&nbsp;new&nbsp;int[256];</li>
<li>for(int&nbsp;row=0;&nbsp;row&lt;height;&nbsp;row++)&nbsp;{</li>
<li>int&nbsp;tr&nbsp;=&nbsp;0;</li>
<li>for(int&nbsp;col=0;&nbsp;col&lt;width;&nbsp;col++)&nbsp;{</li>
<li>index&nbsp;=&nbsp;row&nbsp;*&nbsp;width&nbsp;+&nbsp;col;</li>
<li>tr&nbsp;=&nbsp;(inPixels[index]&nbsp;&gt;&gt;&nbsp;16)&nbsp;&amp;&nbsp;0xff;</li>
<li>histogram[tr]++;</li>
<li>}</li>
<li>}</li>
<li>//&nbsp;图像二值化&nbsp;-&nbsp;OTSU&nbsp;阈值化方法</li>
<li>double&nbsp;total&nbsp;=&nbsp;width&nbsp;*&nbsp;height;</li>
<li>double[]&nbsp;variances&nbsp;=&nbsp;new&nbsp;double[256];</li>
<li>for(int&nbsp;i=0;&nbsp;i&lt;variances.length;&nbsp;i++)</li>
<li>{</li>
<li>double&nbsp;bw&nbsp;=&nbsp;0;</li>
<li>double&nbsp;bmeans&nbsp;=&nbsp;0;</li>
<li>double&nbsp;bvariance&nbsp;=&nbsp;0;</li>
<li>double&nbsp;count&nbsp;=&nbsp;0;</li>
<li>for(int&nbsp;t=0;&nbsp;t&lt;i;&nbsp;t++)</li>
<li>{</li>
<li>count&nbsp;+=&nbsp;histogram[t];</li>
<li>bmeans&nbsp;+=&nbsp;histogram[t]&nbsp;*&nbsp;t;</li>
<li>}</li>
<li>bw&nbsp;=&nbsp;count&nbsp;/&nbsp;total;</li>
<li>bmeans&nbsp;=&nbsp;(count&nbsp;==&nbsp;0)&nbsp;?&nbsp;0&nbsp;:(bmeans&nbsp;/&nbsp;count);</li>
<li>for(int&nbsp;t=0;&nbsp;t&lt;i;&nbsp;t++)</li>
<li>{</li>
<li>bvariance&nbsp;+=&nbsp;(Math.pow((t-bmeans),2)&nbsp;*&nbsp;histogram[t]);</li>
<li>}</li>
<li>bvariance&nbsp;=&nbsp;(count&nbsp;==&nbsp;0)&nbsp;?&nbsp;0&nbsp;:&nbsp;(bvariance&nbsp;/&nbsp;count);</li>
<li>double&nbsp;fw&nbsp;=&nbsp;0;</li>
<li>double&nbsp;fmeans&nbsp;=&nbsp;0;</li>
<li>double&nbsp;fvariance&nbsp;=&nbsp;0;</li>
<li>count&nbsp;=&nbsp;0;</li>
<li>for(int&nbsp;t=i;&nbsp;t&lt;histogram.length;&nbsp;t++)</li>
<li>{</li>
<li>count&nbsp;+=&nbsp;histogram[t];</li>
<li>fmeans&nbsp;+=&nbsp;histogram[t]&nbsp;*&nbsp;t;</li>
<li>}</li>
<li>fw&nbsp;=&nbsp;count&nbsp;/&nbsp;total;</li>
<li>fmeans&nbsp;=&nbsp;(count&nbsp;==&nbsp;0)&nbsp;?&nbsp;0&nbsp;:&nbsp;(fmeans&nbsp;/&nbsp;count);</li>
<li>for(int&nbsp;t=i;&nbsp;t&lt;histogram.length;&nbsp;t++)</li>
<li>{</li>
<li>fvariance&nbsp;+=&nbsp;(Math.pow((t-fmeans),2)&nbsp;*&nbsp;histogram[t]);</li>
<li>}</li>
<li>fvariance&nbsp;=&nbsp;(count&nbsp;==&nbsp;0)&nbsp;?&nbsp;0&nbsp;:&nbsp;(fvariance&nbsp;/&nbsp;count);</li>
<li>variances[i]&nbsp;=&nbsp;bw&nbsp;*&nbsp;bvariance&nbsp;+&nbsp;fw&nbsp;*&nbsp;fvariance;</li>
<li>}</li>
<li>//&nbsp;find&nbsp;the&nbsp;minimum&nbsp;within&nbsp;class&nbsp;variance</li>
<li>double&nbsp;min&nbsp;=&nbsp;variances[0];</li>
<li>int&nbsp;threshold&nbsp;=&nbsp;0;</li>
<li>for(int&nbsp;m=1;&nbsp;m&lt;variances.length;&nbsp;m++)</li>
<li>{</li>
<li>if(min&nbsp;&gt;&nbsp;variances[m]){</li>
<li>threshold&nbsp;=&nbsp;m;</li>
<li>min&nbsp;=&nbsp;variances[m];</li>
<li>}</li>
<li>}</li>
<li>//&nbsp;二值化</li>
<li>System.out.println("final&nbsp;threshold&nbsp;value&nbsp;:&nbsp;"&nbsp;+&nbsp;threshold);</li>
<li>for(int&nbsp;row=0;&nbsp;row&lt;height;&nbsp;row++)&nbsp;{</li>
<li>for(int&nbsp;col=0;&nbsp;col&lt;width;&nbsp;col++)&nbsp;{</li>
<li>index&nbsp;=&nbsp;row&nbsp;*&nbsp;width&nbsp;+&nbsp;col;</li>
<li>int&nbsp;gray&nbsp;=&nbsp;(inPixels[index]&nbsp;&gt;&gt;&nbsp;8)&nbsp;&amp;&nbsp;0xff;</li>
<li>if(gray&nbsp;&gt;&nbsp;threshold)</li>
<li>{</li>
<li>gray&nbsp;=&nbsp;255;</li>
<li>outPixels[index]&nbsp;&nbsp;=&nbsp;(0xff&nbsp;&lt;&lt;&nbsp;24)&nbsp;|&nbsp;(gray&nbsp;&lt;&lt;&nbsp;16)&nbsp;|&nbsp;(gray&nbsp;&lt;&lt;&nbsp;8)&nbsp;|&nbsp;gray;</li>
<li>}</li>
<li>else</li>
<li>{</li>
<li>gray&nbsp;=&nbsp;0;</li>
<li>outPixels[index]&nbsp;&nbsp;=&nbsp;(0xff&nbsp;&lt;&lt;&nbsp;24)&nbsp;|&nbsp;(gray&nbsp;&lt;&lt;&nbsp;16)&nbsp;|&nbsp;(gray&nbsp;&lt;&lt;&nbsp;8)&nbsp;|&nbsp;gray;</li>
<li>}</li>
<li>}</li>
<li>}</li>
<li>setRGB(dest,&nbsp;0,&nbsp;0,&nbsp;width,&nbsp;height,&nbsp;outPixels&nbsp;);</li>
<li>return&nbsp;dest;</li>
<li>}</li>
<li>}</li></ol>
</div>
<p><strong>运行效果图：</strong></p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20150223125748972"></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gedll8.html">swift中 if let 与 guard let 对比&comma;guard会降低一个分支</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pwx178.html">使用sklearn进行集成学习&mdash;&mdash;实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mwk5rq.html">centos 6&period;8 安装 nginx-1&period;11&period;4</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq46jrj8.html">Newtonsoft&period;Json 通过 JObject 读取 json对像 超简单</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9j7j3e9.html">常用JQ特效代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlgjve9.html">java 16-2  ArrayList的练习2</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wd5n3q.html">UVALive 6145 Version Controlled IDE（可持久化treap、rope）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjxwz49.html">对Kernel panic-not syncing&colon;No init found&period;&period;&period;init&equals;option to kernel错误总结&excl;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1wrrj8.html">couldn&amp;&num;39&semi;t set tty to ppp discipline invalid argument</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydx6pdq.html">使用vxsim（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnxpde8.html">动作之CCActionInterval（持续动作）家族</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp0p4zq.html">OutLook 2010 收件箱子文件夹收到新邮件时没有桌面通知</a>
		</li>
						<li><a href="https://www.batexi.com/a/950xjne8.html">开发指南专题八：JEECG微云高速开发平台数据字典</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd0yoy9.html">Dynamics 365使用代码发送邮件给指定邮箱地址</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jyx53q.html">【吴恩达课后编程作业】第二周作业 - Logistic回归-识别猫的图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4jgrj9.html">GitHubPage博客搭建学习专栏</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjkdj39.html">WEBBASE篇： 第七篇， JavaScript知识1</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjr4409.html">Python学习&mdash;基础篇之基本数据类型&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll7x60q.html">json&period;dumps&lpar;&rpar;和json&period;loads&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnz52eq.html">cocos2d-x2&period;2&period;3 Layer分析</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pdelj79.html">javascript中的BOM对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mez1nrq.html">javascript中的Date对象和Math对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gekor48.html">cmake编译安装mysql 5&period;6&period;12</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k211z9.html">ABP官方文档翻译 3&period;1 实体</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zwrn09.html">python扒取百宝彩网站江西快三当日期号及开奖结果</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1xm7xq.html">【linux之文件查看，操作】</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp4w169.html">bzoj 4546&colon; codechef XRQRS &lbrack;可持久化Trie&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj7zzk9.html">【SSH框架】之Hibernate系列一</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1knmw29.html">struct stat结构体简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkrwvv8.html">【特性】select语句中使用字符串链接获取字段值失败</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
